var alertram = 90;
var alertdisk = 90;

var laststats = [];
var allhistory = [];

function deleteSerial(serial) {
  var tr = $("tr[data-serial='" + serial + "']");
  var connected = ($(tr).attr("data-connected") === "true");
  if (connected) {
    if (!confirm("Attention, cet IPBX est actuellement connecté. Etes vous sur de vouloir le supprimer ?"))
      return;
  }
  $(tr).remove();
  $.get("main.php?action=del&serial=" + serial, () => {

  });
}

function UpdateConnexion() {
  $.getJSON("main.php?action=connected", function (data) {
    var ports = data;
    $("[data-type='ipbx']").each(function (index) {
      var tr = this;
      var port1 = $(tr).attr('data-port1');
      var port2 = $(tr).attr('data-port2');
      if (ports.indexOf(port1) > -1 || ports.indexOf(port2) > -1) {
        $(tr).find('.connectstatus').html("<img class='connectstatus' src='img/connected.png' />");
        $(tr).attr('data-connected', true);
      }
      else {
        $(tr).find('.connectstatus').html("<img class='connectstatus' src='img/disconnected.png' />");
        $(tr).attr('data-connected', false);
      }
    });
    filtrer();
  });
}


async function UpdateAllStatsAsync() {
  return new Promise((resolve, reject) => {
    try {
      $.getJSON("main.php?action=laststats", (data) => {
        laststats = data;
        //Met à jour le tableau.
        for (var d of laststats) {
          var tr = $("[data-serial='" + d.serial + "']");
          var serial = d.serial;
          $(tr).attr('data-has-stats', true);
          $(tr).find('.td-stats').html("<a href='#' onclick='displayLastStatsAsync(\"" + serial + "\")'><i class='glyphicon glyphicon-stats'></i> voir</a>");

          var usedrampercent = (d.totalram - d.availableram) * 100 / d.totalram;
          var totaldisk = parseInt(d.totaldisk);
          var freedisk = parseInt(d.freedisk);
          var useddisk = totaldisk - freedisk;
          var useddiskpercent = ((useddisk * 100) / totaldisk).toFixed(2);

          var alert = false;
          if (usedrampercent > alertram)
            alert = true;
          if (useddiskpercent > alertdisk)
            alert = true;

          if (alert) {
            $(tr).find('.td-alarm').html("<i class='glyphicon glyphicon-warning-sign'></i>");
            $(tr).attr('data-has-alarm', true);
          }
          else {
            $(tr).find('.td-alarm').html("");
            $(tr).attr('data-has-alarm', false);
          }
        }
        $("[data-has-stats='false']").find('.td-stats').html('');
        var afficherAlarmes = $("#checkbox-afficher-alarmes").prop("checked");
        if (afficherAlarmes) {
          $("[data-has-alarm='true']").show();
        }
        resolve();
      });
    }
    catch (e) {
      reject(e);
    }
  });
}


async function updateHistory() {
  return new Promise((resolve, reject) => {
    try {
      $.getJSON("main.php?action=statshistory&days=1", (data) => {
        allhistory = data;
        resolve();
      });
    }
    catch (e) {
      reject(e);
    }
  });
}


async function drawChart(placeholder, historysource, ymax, yticks) {
  var chartdata = new google.visualization.DataTable();
  chartdata.addColumn('string', 'Time');
  chartdata.addColumn('number', 'Value');
  chartdata.addRows(historysource);
  var chartoptions = {
    legend: {
      position: 'none'
    },
    axisTitlesPosition: 'none',
    enableInteractivity: true,
    hAxis: {
      textPosition: 'none'
    },
    vAxis: {
      minValue: 0,
      maxValue: ymax,
      ticks: yticks !== null ? yticks : 'auto'
    },
    lineWidth: 1,
    pointsVisible: false,
    chartArea: {
      left: 20,
      right: 0
    },
    backgroundColor: {
      stroke: '#cdcdcd',
      strokeWidth: 1
    }
  }
  var chart = new google.visualization.LineChart(placeholder);
  chart.draw(chartdata, chartoptions);
}


function getHistorySerialFromCache(serial) {
  var history = [];
  for (var h of allhistory) {
    if (h.serial === serial) {
      history.push(h);
    }
  }
  return history;
}


function getStatsSerialFromCache(serial) {
  for (var s of laststats) {
    if (s.serial === serial) {
      return s;
    }
  }
  return null;
}

async function displayLastStatsAsync(serial) {
  $("#modalstats").modal("show");
  $("#modalstats").find('.chart').html('Loading...');

  $(".title-loading-stats").show();
  $(".stats-nostats").hide();
  $("#div-stats").hide();
  $(".stat-value").html('');
  var stats = getStatsSerialFromCache(serial);
  if (stats !== null) {
    var totalram = stats.totalram / 1024;
    var usedram = (stats.totalram - stats.availableram) / 1024;
    var usedrampercent = (stats.totalram - stats.availableram) * 100 / stats.totalram;
    var totalswap = stats.swaptotal / 1024;
    var usedwap = (stats.swaptotal - stats.swapfree) / 1024;
    var usedswappercent = (stats.swaptotal - stats.swapfree) * 100 / stats.swaptotal;
    var momdate = moment.unix(stats.date);
    var totalpeers = parseInt(stats.peersoffline) + parseInt(stats.peersonline);
    var diffdate = moment().diff(momdate, 'seconds');
    var totaldisk = parseInt(stats.totaldisk);
    var freedisk = parseInt(stats.freedisk);
    var useddisk = totaldisk - freedisk;
    var useddiskpercent = ((useddisk * 100) / totaldisk).toFixed(2);

    $(".stat-date").html(momdate.format("L LTS") + " - " + momdate.fromNow());
    if (diffdate > 120) {
      $(".stat-date").css('color', 'red');
    }
    else {
      $(".stat-date").css('color', '');
    }
    $(".stat-serial").html(stats.serial);
    $(".stat-version").html(stats.version);
    $(".stat-memoire").html(usedram.toFixed(0) + " MB / " + totalram.toFixed(0) + " MB (" + usedrampercent.toFixed(2) + "%)");
    if (usedrampercent > alertram)
      $(".stat-memoire").addClass('text-danger');
    else
      $(".stat-memoire").removeClass('text-danger');

    $(".stat-swap").html(usedwap.toFixed(0) + " MB / " + totalswap.toFixed(0) + " (" + usedswappercent.toFixed(2) + "%)");

    $(".stat-disk").html(useddisk + " MB / " + totaldisk + " (" + useddiskpercent + "%)");
    if (useddiskpercent > alertdisk)
      $(".stat-disk").addClass('text-danger');
    else
      $(".stat-disk").removeClass('text-danger');

    $(".stat-loadavg").html(stats.loadavg1);
    $(".stat-calls").html(stats.calls + " appels en cours");
    $(".stat-peers").html(stats.peersonline + " connectés / " + totalpeers + " total");
    $(".stat-trunks").html(stats.registered + " trunks enregistrés");
    $("#div-stats").show();

    var historysource = getHistorySerialFromCache(serial);
    //Il faut laisser le temps à la page d'afficher le modal, sinon la taille du modal est à 0, donc le graph s'affiche pas.
    setTimeout(() => {
      var dataloadavg = [];
      var maxLoadAvg = 2;
      var datamemory = [];
      for (var h of historysource) {
        var date = moment.unix(h.date).format("HH:mm");
        dataloadavg.push([date, parseFloat(h.loadavg1)]);
        if (h.loadavg1 > maxLoadAvg) {
          maxLoadAvg = Math.ceil(h.loadavg1);
        }
        datamemory.push([date, ((parseInt(h.totalram) - parseInt(h.availableram)) * 100) / stats.totalram]);
      }
      drawChart($('.chart-loadavg')[0], dataloadavg, null, [0, maxLoadAvg]);
      drawChart($('.chart-memory')[0], datamemory, 100, [0, 25, 50, 75, 100]);
    }, 1000);
  }
  else {
    $(".stats-nostats").show();
  }
  $(".title-loading-stats").hide();
}

function isFiltered(tr) {
  var s = $('#inputfiltre').val().toUpperCase();
  if (s === "") {
    return false;
  }
  else {
    if ($(tr).attr('data-nom').toUpperCase().indexOf(s) === -1
      && $(tr).attr('data-serial').toUpperCase().indexOf(s) === -1
      && $(tr).attr('data-port1').toUpperCase().indexOf(s) === -1
      && $(tr).attr('data-port2').toUpperCase().indexOf(s) === -1) //rien ne correspond
    {
      return true; //le résultat est donc filtré puisque rien ne correspond
    }
    else {
      return false;
    }
  }
}

function filtrer() {
  var afficherDecos = $("#checkbox-afficher-deconnectes").prop("checked");
  var afficherAlarmes = $("#checkbox-afficher-alarmes").prop("checked");
  $("[data-type='ipbx']").each(function (index) {
    if (isFiltered($(this))) {
      $(this).hide();
    }
    else {
      var connected = ($(this).attr("data-connected") === "true");
      var alarme = ($(this).attr("data-has-alarm") === "true");
      if (!connected) {
        if (afficherDecos) {
          $(this).show();
        }
        else {
          $(this).hide();
        }
      }
      else {
        $(this).show();
      }

      if (afficherAlarmes && !alarme) {
        $(this).hide();
      }
    }
  });
}var alertram=90,alertdisk=90,laststats=[],allhistory=[];function deleteSerial(t){var a=$("tr[data-serial='"+t+"']");"true"===$(a).attr("data-connected")&&!confirm("Attention, cet IPBX est actuellement connecté. Etes vous sur de vouloir le supprimer ?")||($(a).remove(),$.get("main.php?action=del&serial="+t,()=>{}))}function UpdateConnexion(){$.getJSON("main.php?action=connected",(function(t){var a=t;$("[data-type='ipbx']").each((function(t){var e=this,s=$(e).attr("data-port1"),r=$(e).attr("data-port2");a.indexOf(s)>-1||a.indexOf(r)>-1?($(e).find(".connectstatus").html("<img class='connectstatus' src='img/connected.png' />"),$(e).attr("data-connected",!0)):($(e).find(".connectstatus").html("<img class='connectstatus' src='img/disconnected.png' />"),$(e).attr("data-connected",!1))})),filtrer()}))}async function UpdateAllStatsAsync(){return new Promise((t,a)=>{try{$.getJSON("main.php?action=laststats",a=>{for(var e of laststats=a){var s=$("[data-serial='"+e.serial+"']"),r=e.serial;$(s).attr("data-has-stats",!0),$(s).find(".td-stats").html("<a href='#' onclick='displayLastStatsAsync(\""+r+"\")'><i class='glyphicon glyphicon-stats'></i> voir</a>");var i=100*(e.totalram-e.availableram)/e.totalram,o=parseInt(e.totaldisk),n=(100*(o-parseInt(e.freedisk))/o).toFixed(2),l=!1;i>alertram&&(l=!0),n>alertdisk&&(l=!0),l?($(s).find(".td-alarm").html("<i class='glyphicon glyphicon-warning-sign'></i>"),$(s).attr("data-has-alarm",!0)):($(s).find(".td-alarm").html(""),$(s).attr("data-has-alarm",!1))}$("[data-has-stats='false']").find(".td-stats").html(""),$("#checkbox-afficher-alarmes").prop("checked")&&$("[data-has-alarm='true']").show(),t()})}catch(t){a(t)}})}async function updateHistory(){return new Promise((t,a)=>{try{$.getJSON("main.php?action=statshistory&days=1",a=>{allhistory=a,t()})}catch(t){a(t)}})}async function drawChart(t,a,e,s){var r=new google.visualization.DataTable;r.addColumn("string","Time"),r.addColumn("number","Value"),r.addRows(a);var i={legend:{position:"none"},axisTitlesPosition:"none",enableInteractivity:!0,hAxis:{textPosition:"none"},vAxis:{minValue:0,maxValue:e,ticks:null!==s?s:"auto"},lineWidth:1,pointsVisible:!1,chartArea:{left:20,right:0},backgroundColor:{stroke:"#cdcdcd",strokeWidth:1}};new google.visualization.LineChart(t).draw(r,i)}function getHistorySerialFromCache(t){var a=[];for(var e of allhistory)e.serial===t&&a.push(e);return a}function getStatsSerialFromCache(t){for(var a of laststats)if(a.serial===t)return a;return null}async function displayLastStatsAsync(t){$("#modalstats").modal("show"),$("#modalstats").find(".chart").html("Loading..."),$(".title-loading-stats").show(),$(".stats-nostats").hide(),$("#div-stats").hide(),$(".stat-value").html("");var a=getStatsSerialFromCache(t);if(null!==a){var e=a.totalram/1024,s=(a.totalram-a.availableram)/1024,r=100*(a.totalram-a.availableram)/a.totalram,i=a.swaptotal/1024,o=(a.swaptotal-a.swapfree)/1024,n=100*(a.swaptotal-a.swapfree)/a.swaptotal,l=moment.unix(a.date),d=parseInt(a.peersoffline)+parseInt(a.peersonline),c=moment().diff(l,"seconds"),m=parseInt(a.totaldisk),h=m-parseInt(a.freedisk),p=(100*h/m).toFixed(2);$(".stat-date").html(l.format("L LTS")+" - "+l.fromNow()),c>120?$(".stat-date").css("color","red"):$(".stat-date").css("color",""),$(".stat-serial").html(a.serial),$(".stat-version").html(a.version),$(".stat-memoire").html(s.toFixed(0)+" MB / "+e.toFixed(0)+" MB ("+r.toFixed(2)+"%)"),r>alertram?$(".stat-memoire").addClass("text-danger"):$(".stat-memoire").removeClass("text-danger"),$(".stat-swap").html(o.toFixed(0)+" MB / "+i.toFixed(0)+" ("+n.toFixed(2)+"%)"),$(".stat-disk").html(h+" MB / "+m+" ("+p+"%)"),p>alertdisk?$(".stat-disk").addClass("text-danger"):$(".stat-disk").removeClass("text-danger"),$(".stat-loadavg").html(a.loadavg1),$(".stat-calls").html(a.calls+" appels en cours"),$(".stat-peers").html(a.peersonline+" connectés / "+d+" total"),$(".stat-trunks").html(a.registered+" trunks enregistrés"),$("#div-stats").show();var f=getHistorySerialFromCache(t);setTimeout(()=>{var t=[],e=2,s=[];for(var r of f){var i=moment.unix(r.date).format("HH:mm");t.push([i,parseFloat(r.loadavg1)]),r.loadavg1>e&&(e=Math.ceil(r.loadavg1)),s.push([i,100*(parseInt(r.totalram)-parseInt(r.availableram))/a.totalram])}drawChart($(".chart-loadavg")[0],t,null,[0,e]),drawChart($(".chart-memory")[0],s,100,[0,25,50,75,100])},1e3)}else $(".stats-nostats").show();$(".title-loading-stats").hide()}function isFiltered(t){var a=$("#inputfiltre").val().toUpperCase();return""!==a&&(-1===$(t).attr("data-nom").toUpperCase().indexOf(a)&&-1===$(t).attr("data-serial").toUpperCase().indexOf(a)&&-1===$(t).attr("data-port1").toUpperCase().indexOf(a)&&-1===$(t).attr("data-port2").toUpperCase().indexOf(a))}function filtrer(){var t=$("#checkbox-afficher-deconnectes").prop("checked"),a=$("#checkbox-afficher-alarmes").prop("checked");$("[data-type='ipbx']").each((function(e){if(isFiltered($(this)))$(this).hide();else{var s="true"===$(this).attr("data-connected"),r="true"===$(this).attr("data-has-alarm");s||t?$(this).show():$(this).hide(),a&&!r&&$(this).hide()}}))}
